***   Program 1_7_1   ***;
TITLE1 'Hanging Histogram and Hanging Rootogram';
TITLE2 'Beeswax Data';
LIBNAME datalib 'c:\data';

PROC MEANS DATA=datalib.beeswax NOPRINT MEAN STD N;
   VAR degree;
   OUTPUT OUT=meandata MEAN=mu STD=sigma N=n;

DATA data1;
  SET meandata;
  DO i=-4.5 TO 5.5 BY 1;
    model=(PROBNORM(i+1)-PROBNORM(i))*n;   * theoretical frequencies;
    freqncy=0;
    DO k=1 TO n;
      SET datalib.beeswax POINT=k;
      degree=(degree-mu)/sigma;            * studentisation;
      IF i< degree <=i+1 THEN freqncy+1;   * indicator function;
    END;
    diff =freqncy-model;                   * value for 'Histogram';
    rdiff=SQRT(freqncy)-SQRT(model);       * value for 'Rootogram';
    center=i+0.5;                          * interval center;
    OUTPUT;
  END; STOP;

AXIS1 LABEL=('I(j)');
AXIS2 LABEL=(A=90 'N(j) - np(j)')
      ORDER=(-4 TO 4 BY 1);
AXIS3 LABEL=(A=90  F=MATH 'a'  F=COMPLEX 'N(j) - '
                   F=MATH 'a'  F=COMPLEX 'np(j)')
      ORDER=(-4 TO 4 BY 1);

PROC GCHART DATA=data1;
   TITLE1 'Hanging Histogram';
   TITLE2 'Beeswax Data';
   VBAR center / DISCRETE SUM  SUMVAR=diff SPACE=0
                RAXIS=AXIS2   MAXIS=AXIS1;
RUN;
   TITLE1 'Hanging Rootogram';
   TITLE2 'Beeswax Data';
   VBAR center / DISCRETE SUM  SUMVAR=rdiff SPACE=0
                 RAXIS=AXIS3   MAXIS=AXIS1;
RUN; QUIT;
