***   Program 6_4_3   ***;
TITLE1 'Original and transformed Data';
TITLE2 'Crystal Data';
LIBNAME datalib 'c:\data';

DATA letter(KEEP=mosm urea text); 
   SET datalib.crystal;
   INPUT text $ @@; OUTPUT;
   CARDS;
A B C D E F G H I J K L M N O P Q R S T
; 

PROC STANDARD DATA=letter M=0 OUT=data1;

PROC IML;
   USE data1 VAR{mosm urea};  * reading standardized Data       ;
   READ ALL INTO x;
   covm=(x`*x)*(1/19);        * covariance matrix               ;
   is=INV(covm);              * inverse covariance matrix       ;
   CALL SVD(u,q,v,is);        * decomposition for computation   ;
   isv=u*DIAG(SQRT(q))*u`;    * of inverse symmetric roots (isv);
   t_x=x*isv;
   vn={t_mosm t_urea};
   CREATE new1 FROM t_x [COLNAME=vn];
   APPEND FROM t_x;
QUIT;                         * IML verlassen             ;

DATA datalib.o_anno t_anno;
   MERGE data1 new1;
   FUNCTION='TEXT';  POSITION='2';  XSYS='2';  YSYS='2';
   SIZE=1.1;
   X=mosm;    Y=urea;    OUTPUT datalib.o_anno;
   X=t_mosm;  Y=t_urea;  OUTPUT t_anno;

GOPTIONS NODISPLAY;
SYMBOL1  V=NONE  I=NONE;
PROC GPLOT DATA=datalib.o_anno GOUT=figure;
TITLE1 'Scatter Plot of Original Data';
   PLOT y*x /ANNO=datalib.o_anno NAME='original';


PROC GPLOT DATA=t_anno GOUT=figure;
TITLE1 'Scatter Plot of transformed Data';
   PLOT y*x /ANNO=t_anno NAME='transfor';
RUN;  QUIT;

GOPTIONS DISPLAY;
PROC GREPLAY IGOUT=figure NOFS TC=SASHELP.TEMPLT TEMPLATE=H2;
   TREPLAY 1:original
           2:transfor;
RUN;
   DELETE _ALL_;
RUN; QUIT;
