***   Program 6_4_4   ***;
TITLE1 'Density Estimator';
TITLE2 'Crystal Data';
LIBNAME datalib 'c:\data';

DATA data1;
  a= 0.0078622;  b=-0.008428;  * inverse symmetric root;
  c=-0.008428;   d= 0.019606;  * of covariance matrix;

  sdet=12031.507;              * determinant of sym. root;
  n=20;                        * sample size;
  h=2;                         * choice of bandwidth;

  DO x1=-600 TO 600 BY 50;     * computation of density estimator;
   DO x2=-600 TO 600 BY 50;    * using the data;
    fn_o=0;  fn_t=0;           * from program 6_4_1;
    DO i=1 TO n;
     SET datalib.o_anno POINT=i;
     fn_o=fn_o+EXP(-0.5*(((x1-mosm)/h)**2+((x2-urea)/h)**2));
     fn_t=fn_t+EXP(-0.5*(((a*(x1-mosm))/h + (b*(x2-urea))/h)**2
                        +((c*(x1-mosm))/h + (d*(x2-urea))/h)**2));
  END;
  twopi=6.2831853;
  fn_o=fn_o/(twopi*n*h**2);
  fn_t=fn_t/(twopi*sdet*n*h**2);
  OUTPUT;  END;  END;  STOP;

GOPTIONS NODISPLAY;
PROC G3D DATA=data1 GOUT=figure;
   PLOT x1*x2=fn_o / NAME='original';
RUN;  QUIT;

TITLE1 'Density Estimator with Data Sphering';
PROC G3D DATA=data1 GOUT=figure;
   PLOT x1*x2=fn_t / NAME='transfor';
RUN;  QUIT;
GOPTIONS DISPLAY;
PROC GREPLAY IGOUT=figure TC=SASHELP.TEMPLT NOFS TEMPLATE=H2;
   TREPLAY 1:original 2:transfor;
RUN;
   DELETE _ALL_;
RUN; QUIT;
