***   Program 7_2_2   ***;
TITLE1 'Mahalanobis Distance Matrix';
TITLE2 'Air Pollution II Data';
LIBNAME datalib 'c:\data';

DATA sub15;
   SET datalib.polution(OBS=15);
PROC CORR DATA=sub15 OUTP=covmat COV NOPRINT;
   VAR smean pmean pm2 perwh nonpoor ge65;

PROC IML;
*** import data from datasets sub15 and covmat;
  USE sub15;
  READ ALL VAR{smean pmean pm2 perwh nonpoor ge65} INTO x;
  USE covmat WHERE(_TYPE_='COV');
  READ ALL VAR{smean pmean pm2 perwh nonpoor ge65} INTO s;
***  computation of distance matrix 'dist' ;
***  as lower triangular matrix            ;
  dist=J(15,15,.);
  s_inv=INV(s);                     * s_inv=inverse matrix of s;
  DO k=1 TO 15;
    DO l=1 TO k;
      d1=(x[k,]-x[l,]);
      dist[k,l]=SQRT(d1 * s_inv * d1`); * see Definition 7.2.4;
    END;
  END;
  CREATE mahal FROM dist;           * export matrix to dataset;
  APPEND FROM dist;
QUIT;                               * quit IML;

*** create data set of type 'DISTANCE'  ;
DATA datalib.dist1(TYPE=DISTANCE);
   MERGE sub15 mahal;
PROC PRINT DATA=datalib.dist1(OBS=7) ROUND;
  VAR city COL1-COL7;
RUN;  QUIT;
