***   Program 7_2_4   ***;
*TITLE1 'Similarity Matrix of Binary Variables';
*TITLE2 'Ground for Divorce Data';
LIBNAME datalib 'c:\data';

PROC IML;
*** import data   ;
  USE datalib.grounds where(sub='J');
  READ ALL VAR _NUM_ INTO x;
  p=NCOL(x);                     * p = number of variables;
  n=NROW(x);                     * n = number of observations;

*** computation of distance matrices ;
*** as lower triangular matrices ;
*** selection of coefficient by removing asterix '*' ;
  dist=J(n,n,.);
  DO k=1 TO n;
    DO l=1 TO k;
       a=x[k,] * x[l,]`;
       b=x[k,] * (1-x[l,]`);
       c=x[l,] * (1-x[k,]`);
       d=(1-x[k,]) * (1-x[l,]`);
       IF d=p THEN dist[k,l]=1; ELSE
       dist[k,l]=a / (a+b+c);          * Jaccard;
*       dist[k,l]=2*a / (2*a+b+c);     * Czekanowski;
*       dist[k,l]=(a+d) / p;           * Matching;
    END;
  END;
  CREATE distb FROM dist;        * export data;
  APPEND FROM dist;
QUIT;                            * quit IML;

DATA distb(TYPE=DISTANCE);
   MERGE datalib.grounds(WHERE=(sub='J')) distb;
PROC PRINT DATA=distb(OBS=8) ROUND;
  VAR COL1-COL8;
  ID  state;
RUN; QUIT;
