***   Program 7_3_1   ***;
TITLE1 'MDS Plot';
TITLE2 'Distance Matrix from Figure 7.2.1';
LIBNAME datalib 'c:\data';

PROC IML;
name={ 'El Paso', 'Flagstaff', 'Los Angeles', 'Las Vegas', 'Phoenix',
      'Reno', 'Salt Lake City', 'San Diego', 'San Francisco', 'Tucson'};
dist={  0  544  870  686  401 1132  919  724 1270  310,
        0    0  478  246  137  692  509  490  773  255,
        0    0    0  276  376  470  707  127  387  524,
        0    0    0    0  285  446  431  331  571  403,
        0    0    0    0    0  731  646  353  763  118,
        0    0    0    0    0    0  520  571  225  849,
        0    0    0    0    0    0    0  762  745  764,
        0    0    0    0    0    0    0    0  514  414,
        0    0    0    0    0    0    0    0    0  911,
        0    0    0    0    0    0    0    0    0    0};
DO k=1 TO 10;
   DO l=1 TO k;
      dist[l,k]=dist[l,k]**2;
      dist[k,l]=dist[l,k];
   END;
END;

dist=dist*0.001;
i10=I(10);
e10=J(10,10,1);
p=(i10-(1/10)*e10);
a1=-.5*XMULT(p,dist);           *  Formel (7.1);
a=XMULT(a1,p);                  *  Formel (7.1);
CALL EIGEN(l,r,a);
x=J(10,9,.);
DO k=1 TO 9;
  IF k=1 then
  x[,k]=(l[k]**.5)*r[,k];       *  Loesung des MDS-Problems;
  else x[,k]=-((l[k])**.5)*r[,k];
END;

CREATE mds1 FROM x;
APPEND FROM x;
CREATE namen FROM name;
APPEND FROM name;
QUIT;
DATA mds2;
   MERGE namen(RENAME=(COL1=name)) mds1;
DATA annomds;
   SET mds2;
   FUNCTION='LABEL'; TEXT=name; XSYS='2'; YSYS='2';  HSYS='4';
   POSITION='3';  SIZE=1.5;   X=COL2; Y=COL1;
   IF name IN('El Paso' 'San Diego' 'Las Vegas')  THEN POSITION='1';
   IF name IN('Los Angeles' 'Las Vegas') THEN POSITION='7';
RUN;
SYMBOL1 V=DOT  C=GREEN  H=0.6;
PROC GPLOT DATA=mds2;
   PLOT col1*col2 / ANNOTATE=annomds NOAXIS HREF=0 VREF=0;
RUN; QUIT;
