***   Program 7_3_2   ***;
TITLE1 'MDS Plot';
TITLE2 'Economy Data';
LIBNAME datalib 'c:\data';

PROC STANDARD DATA=datalib.economy OUT=economy STD=1;
  VAR invest inflatn gnp nukes unempld;

PROC IML;
***   import dataset economy;
  USE economy;
  READ ALL VAR{invest inflatn gnp nukes unempld} INTO x;
***   computation of distance matrix;
  dist=J(20,20,.);
  DO k=1 TO 20;
    DO l=1 TO 20;
      d1=(x[k,]-x[l,]);
      dist[k,l]=d1*d1`;
    END;
  END;
i20=I(20);
e20=J(20,20,1);
p=(i20-(1/20)*e20);
a1=-.5*XMULT(p,dist);            *  computation of matrix A;
a2=XMULT(a1,p);                  *  from (7.1);
CALL EIGEN(l,r,a2);
x=J(20,5,.);
DO k=1 TO 5;
  x[,k]=(l[k]##.5)*r[,k];        *  solution of MDS problem;
END;
CREATE mds1 FROM x;
APPEND FROM x;
QUIT;                            *  quit IML;

DATA mds2;
   MERGE economy mds1;

DATA annomds;
   SET mds2;
   FUNCTION='LABEL'; TEXT=country; XSYS='2'; YSYS='2';  HSYS='4';
   POSITION='C';  SIZE=1.5;   X=COL2; Y=COL1;
    IF country IN('NETHERLANDS') THEN POSITION='3';
    IF country IN('GREECE') THEN POSITION='6';
    IF country IN('ITALY' 'FINLAND' 'GREAT BRITAIN' 'BELGIUM' 'USA') THEN POSITION='9';
    IF country IN('PORTUGAL' 'LUXEMBURG' 'FRANCE') THEN POSITION='1';
    IF country IN('FINNLAND' 'SWEDEN') THEN POSITION='7';
    IF country IN('BELGIUM') THEN POSITION='F';
    IF country IN('GERMANY') THEN POSITION='A';
RUN;

SYMBOL1 V=DOT  C=GREEN  H=0.6;
PROC GPLOT DATA=mds2;
   PLOT COL1*COL2 / ANNOTATE=annomds NOAXIS HREF=0 VREF=0;
RUN; QUIT;
