***   Program 7_3_3   ***;
TITLE1 'The Additive Constant Problem';
TITLE2 'Habitude Data';
LIBNAME datalib 'c:\data';

PROC IML;
name={Falk, Femir, Retel, Winter, Becker, Marohn};
   **   Fa   Fe   Re   Wi   Be   Ma ;
dist={  0    1   11    3    7    4,  /* Fa */
        0    0   15   14   10   13,  /* Fe */
        0    0    0    9    6    5,  /* Re */
        0    0    0    0    2   12,  /* Wi */
        0    0    0    0    0    8,  /* Be */
        0    0    0    0    0    0}; /* Ma */
DO k=1 TO 6;
   DO l=1 TO k;
      dist[k,l]=dist[l,k];
END; END;
c=90.040866;
i6=I(6);
e6=J(6,6,1);
addkons=(e6-i6)*c;
dist2=(dist+addkons)##2;
p=(i6-(1/6)*e6);
a1=-.5*XMULT(p,dist2);       *   (7.1);
a=XMULT(a1,p);               *   (7.1);
CALL EIGEN(l,r,a);
x=J(6,4,.);
DO k=1 TO 4;
  x[,k]=(l[k]**.5)*r[,k];    *  solution of MDS problem;
END;
CREATE mds1 FROM x;
APPEND FROM x;
CREATE names FROM name;
APPEND FROM name;
QUIT;
DATA mds2;
   MERGE names(RENAME=(COL1=name)) mds1;
DATA annomds;
   SET mds2;
   FUNCTION='LABEL'; TEXT=name; XSYS='2'; YSYS='2';  HSYS='4';
   POSITION='3';  SIZE=1.5;   X=COL2; Y=COL1;
   IF NAME IN('FALK', 'WINTER') THEN POSITION='1';
   RUN;
SYMBOL1 V=DOT  C=GREEN  H=0.6;
PROC GPLOT DATA=mds2;
   PLOT COL1*COL2 / ANNOTATE=annomds NOAXIS HREF=0 VREF=0;
RUN; QUIT;
