***   Program 8_2_5   ***;
TITLE1 'Principal Components';
TITLE2 'Data from Figure 8.1.2';
LIBNAME datalib 'c:\data';

DATA pca2;
   SET datalib.pca1;
   y1=x1;
   y2=1.6093*x2;

SYMBOL1 V=DOT C=RED H=.3 I=NONE;

PROC PRINCOMP DATA=pca2 OUT=pca3 OUTSTAT=stats COV NOPRINT;
   VAR x1 x2;

DATA anno;
   LENGTH FUNCTION $8.;
   SET stats;
   RETAIN mx my l1 l2;
   IF _TYPE_='MEAN'     THEN DO;  mx=x1;        my=x2;        END;
   IF _TYPE_='EIGENVAL' THEN DO;  l1=SQRT(x1);  l2=SQRT(x2);  END;
   IF _TYPE_='SCORE'    THEN DO;
      IF _NAME_='Prin1'  THEN  l=2.5*l1;        ELSE l=2.5*l2;
      XSYS='2';  YSYS='2';  COLOR='RED';
      FUNCTION='MOVE';  X=mx-l*x1;  Y=my-l*x2;  OUTPUT;
      FUNCTION='DRAW';  X=mx+l*x1;  Y=my+l*x2;  OUTPUT;
   END;
GOPTIONS NODISPLAY;
AXIS1 ORDER=(-4 TO 4);
PROC GPLOT DATA=pca2 GOUT=fig8_2_5;
   PLOT x2*x1 / VAXIS=AXIS1 HAXIS=AXIS1 ANNOTATE=anno NAME='miles';
RUN; QUIT;

PROC PRINCOMP DATA=pca2 OUT=pca3 OUTSTAT=stats COV NOPRINT;
   VAR y1 y2;
DATA anno;
   LENGTH FUNCTION $8.;
   SET stats;
   RETAIN mx my l1 l2;
   IF _TYPE_='MEAN'     THEN DO;  mx=y1;        my=y2;        END;
   IF _TYPE_='EIGENVAL' THEN DO;  l1=SQRT(y1);  l2=SQRT(y2);  END;
   IF _TYPE_='SCORE'    THEN DO;
      IF _NAME_='Prin1'  THEN  l=2.5*l1;        ELSE l=2.5*l2;
      XSYS='2';  YSYS='2';  COLOR='RED';
      FUNCTION='MOVE';  X=mx-l*y1;  Y=my-l*y2;  OUTPUT;
      FUNCTION='DRAW';  X=mx+l*y1;  Y=my+l*y2;  OUTPUT;
   END;

PROC GPLOT DATA=pca2 GOUT=fig8_2_5;
   PLOT y2*y1 / VAXIS=AXIS1 HAXIS=AXIS1 ANNOTATE=anno NAME='km';
*TITLE2 'transformed data'; RUN; QUIT;

GOPTIONS DISPLAY;
PROC GREPLAY IGOUT=fig8_2_5  NOFS
   TC=SASHELP.TEMPLT  TEMPLATE=H2;
   TREPLAY 1:miles 2:km;
RUN; DELETE _ALL_; RUN; QUIT;
